#pragma config(Sensor, S1,     leftColor,      sensorEV3_Color)
#pragma config(Sensor, S3,     rightColor,     sensorEV3_Color)
#pragma config(Motor,  motorB,          leftMotor,     tmotorEV3_Large, openLoop, encoder)
#pragma config(Motor,  motorC,          rightMotor,    tmotorEV3_Large, openLoop, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

float u, vL, vR, p, d; // drobnye peremennye
int eL, eR, enL=0, enR=0, e, eOld=0; // celye peremennye

const int lenght=1500, len=33, v=77; // drobnye constanty
const float kSensP=0.4, kSensD=2.3, kV=2; // celye constanty

int encL[lenght], encR[lenght]; // massivy

task line() // dvigenie po linii na PD regulyatore
{
	float kP=0.7, kD=3.6;

	while(true)
	{
		e=SensorValue(leftColor)-SensorValue(rightColor);
		p=e*kP;
		d=(e-eOld)*kD;
		u=p+d;
		eOld=e;

		motor[leftMotor]=v+u;
		motor[rightMotor]=v-u;
		sleep(1);
	}
}


task main()
{
	while(!getButtonPress(buttonUp)) // posle starta gdem nagatie knopki
		sleep(1);

	nMotorEncoder[leftMotor]=nMotorEncoder[rightMotor]=0; // obnulyaem enkodery pered zapis'y
	startTask(line); // edem po linii v parallel'noy zadache

	for(int n=0; n<lenght; n++) // i pri etom zapisyvaem pokazaniya enkoderov v massivy
	{
		encL[n]=nMotorEncoder[leftMotor];
		encR[n]=nMotorEncoder[rightMotor];
		sleep(len); // zapis' delaem kagdye "len" ms
	}
	stopTask(line); // kogda massivy zapolnyatsa ostanavlivaemsay

	motor[leftMotor]=motor[rightMotor]=0;

	while(!getButtonPress(buttonUp)) // i snove gdem nagatie knopki (stavim robota na poligon)
		sleep(1);

	eOld=0;
	nMotorEncoder[leftMotor]=nMotorEncoder[rightMotor]=0; // obnulyaem enkodery pered prochteniem
	for(int n=0; n<lenght; n++) // poka ne prochtaem vse pokazaniya
	{
		enL=encL[n]; // chitaem te, kotorye nygny seychas
		enR=encR[n];

		for(int m=0; m<len; m++) // rasbivaem "len" na deystviya po 1 ms
		{
			eL=enL-nMotorEncoder[leftMotor]; //oshibka enkodera ravna pokazanie iz zapisi - pokazanie enkodera
			eR=enR-nMotorEncoder[rightMotor];

			vL=eL*kV; // domnagaem na koefficient
			vR=eR*kV;
			e=(SensorValue(leftColor)-SensorValue(rightColor)); // xhitaem datchiki (P-regulyator)
			p=e*kSensP;
			d=(e-eOld)*kSensD;
			u=p+d;
			eOld=e;

			if(abs(vL)>100) // esli otklonenie po moduly bol'she 100
				vL=sgn(vL)*100; // to ono ravno Znak * 100

			if(abs(vR)>100)
				vR=sgn(vR)*100;

			motor[leftMotor]=vL+u; // vL i vR - skorost', vyschtannaya po zapisi, a u - upravlenie po datchikam
			motor[rightMotor]=vR-u;
			sleep(1);
		}
	}
}
